mkpkgng.in revision 271947
1#!/bin/sh
2#-
3# Copyright (c) 2013 Dag-Erling Sm��rgrav
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10#    notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12#    notice, this list of conditions and the following disclaimer in the
13#    documentation and/or other materials provided with the distribution.
14# 3. The name of the author may not be used to endorse or promote
15#    products derived from this software without specific prior written
16#    permission.
17#
18# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
19# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
20# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
21# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
22# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
23# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
24# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
25# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
26# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
27# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
28# SUCH DAMAGE.
29#
30# $Id: mkpkgng.in 816 2014-09-12 07:50:22Z des $
31#
32
33# Print an informational message
34info() {
35	echo "mkpkgng: $@"
36}
37
38# Print an error message and exit
39error() {
40	echo "mkpkgng: $@" 1>&2
41	exit 1
42}
43
44# Ask a yes / no question
45yesno() {
46        while :; do
47                echo -n "mkpkgng: $@ (yes/no) "
48                read answer
49                case $answer in
50                [Yy]|[Yy][Ee][Ss])
51                        return 0
52                        ;;
53                [Nn]|[Nn][Oo])
54                        return 1
55                        ;;
56                esac
57        done
58}
59
60#
61# Locate source and build directory
62#
63srcdir="@abs_top_srcdir@"
64[ -f "$srcdir/include/security/openpam.h" ] || \
65    error "Unable to locate source directory."
66builddir="@abs_top_builddir@"
67cd "$srcdir"
68
69#
70# Determine pkgng version and ABI
71#
72pkgver=$(pkg -v)
73[ -n "$pkgver" ] || error "Unable to determine pkgng version."
74pkgabi=$(pkg config abi)
75[ -n "$pkgabi" ] || error "Unable to determine package ABI."
76
77#
78# Determine package name and version
79#
80package="@PACKAGE@"
81version="@PACKAGE_VERSION@"
82if ! expr "$version" : "[0-9]{1,}$" >/dev/null ; then
83	svnversion="$(svnversion 2>&1)"
84	svnversion=$(expr "$svnversion" : '\([0-9][0-9]*\)[A-Z]\{0,1\}$')
85	if [ -n "$svnversion" ] ; then
86		version="$version-r${svnversion}"
87	fi
88fi
89
90#
91# Locate GNU make
92#
93if which gmake >/dev/null ; then
94	make=gmake
95else
96	make=make
97fi
98make="$make --no-print-directory --quiet V=0"
99
100#
101# Create temporary directory
102#
103info "Creating the temporary directory."
104tmproot=$(mktemp -d "${TMPDIR:-/tmp}/$package-$version.XXXXXX")
105[ -n "$tmproot" -a -d "$tmproot" ] || \
106    error "Unable to create the temporary directory."
107trap "exit 1" INT
108trap "info Deleting the temporary directory. ; rm -rf '$tmproot'" EXIT
109set -e
110
111#
112# Install into tmproot
113#
114info "Installing into the temporary directory."
115$make install DESTDIR="$tmproot"
116
117#
118# Generate stub manifest
119#
120info "Generating the stub manifest."
121manifest="$tmproot/+MANIFEST"
122cat >"$manifest" <<EOF
123name: $package
124version: $version
125origin: local/$package
126comment: BSD-licensed PAM implementation
127arch: $pkgabi
128www: @PACKAGE_URL@
129maintainer: @PACKAGE_BUGREPORT@
130prefix: @prefix@
131desc:
132  OpenPAM is an open source PAM library that focuses on simplicity,
133  correctness, and cleanliness.
134  
135  OpenPAM aims to gather the best features of Solaris PAM, XSSO and
136  Linux-PAM, plus some innovations of its own.  In areas where these
137  implementations disagree, OpenPAM tries to remain compatible with
138  Solaris, at the expense of XSSO conformance and Linux-PAM
139  compatibility.
140categories: local, security
141EOF
142
143#
144# Generate file list
145#
146info "Generating the file list."
147(
148	echo "files:"
149	find -s "$tmproot" -type f | while read file ; do
150		[ "$file" = "$manifest" ] && continue
151		mode=$(stat -f%p "$file" | cut -c 3-)
152		file="${file#$tmproot}"
153		echo "  $file: { uname: root, gname: wheel, perm: $mode }"
154	done
155)>>"$manifest"
156
157#
158# Create the package
159#
160info "Creating the package."
161pkg create -r "$tmproot" -m "$tmproot" -o "$builddir"
162
163#
164# Done
165#
166info "Package created for $package-$version."
167